//---------------------------------------------------------------------------

#ifndef RsRegisterCOMH
#define RsRegisterCOMH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
typedef void __fastcall (__closure *TRsRegisterEvent)(System::TObject* Sender,String Message);
enum TServerType {ctInProcess , ctOutProcess};
class PACKAGE TRsRegisterCOM : public TComponent
{
private:
        String FCOMServer;
        TRsRegisterEvent FOnError;
        TServerType FCOMType;
        void __fastcall DoInProcess();
        void __fastcall DoUnRegInProcess();
        void __fastcall DoUnRegOutProcess();
        void __fastcall DoOutProcess();
protected:
public:
        __fastcall TRsRegisterCOM(TComponent* Owner);
        void __fastcall Register();
        void __fastcall UnRegister();
__published:
        __property String COMServerFileName  = { read=FCOMServer, write=FCOMServer };
        __property TRsRegisterEvent OnError  = { read=FOnError, write=FOnError };
        __property TServerType COMType  = { read=FCOMType, write=FCOMType };
};
//---------------------------------------------------------------------------
#endif
 